# -------------------------------------------------
# Project created by QtCreator 2009-11-05T12:31:57
# -------------------------------------------------

# We will use the built in Qt lib template
TEMPLATE = lib
QT += opengl
QT += core
QT += gui
###### experimental clang / llvm versions not really used
#QMAKE_CXX=llvm-g++
#QMAKE_CXX=/usr/bin/clang++ --analyze -Wgnu -working-directory $$(HOME)/NGL/  -pedantic -fdiagnostics-fixit-info
# set the base directory of our project so Qt knows where to find them
# we can use shell vars but need to use $$
BASE_DIR = $$(HOME)/NGL
# This is the output target we want to create
TARGET = $$BASE_DIR/lib/NGL
# this is where we want to put the intermediate build files ( ../obj)
OBJECTS_DIR = $$BASE_DIR/obj
QMAKE_LFLAGS-= -headerpad_max_install_names
QMAKE_LFLAGS_SHLIB -= -single_module
QMAKE_LFLAGS_VERSION=
QMAKE_LFLAGS_COMPAT_VERSION=
QMAKE_LFLAGS_SONAME=


# define the NGL_DEBUG flag for the graphics lib
DEFINES += NGL_DEBUG
# this define stops the python lib build and includes
INCLUDEPATH +=/usr/local/boost
#set some flags for sse etc
QMAKE_CXXFLAGS+= -msse -msse2 -msse3 -fms-extensions
# on my mac I can only compile as i386 at present
macx:QMAKE_CXXFLAGS+= -arch x86_64 -fPIC
macx:LIBS+= -L/System/Library/Frameworks/OpenGL.framework/Libraries -framework OpenGL
macx:LIBS+=  -Wl,-framework,Cocoa
# on linux we can use the native flag and it will pick up the correct version
linux-g++:QMAKE_CXXFLAGS+=  -march=native
linux-g++-64:QMAKE_CXXFLAGS+=  -march=native

# The windows configuration is very frustrating however I seem to have it working now
# you will need to install boost in the path below
# once you have done this set the PATH environment variable to look in
# c:/NGL/lib to find the DLL
win32: {
        message(Please Ensure you have boost_1_44_0 installed and in the directory below)
        message(you will also need to set you path to point to C:\NGL\lib and the Qt install)
        message(directories C:\Qt\bin C:\Qt\qt\bin as this is where the debug libs are)
        LIBS += -lmingw32
        LIBS += -lstdc++
        DEFINES += WIN32
        DEFINES += USING_GLEW
        DEFINES +=GLEW_STATIC
        INCLUDEPATH += C:/boost_1_44_0
        INCLUDEPATH += C:/boost
        LIBS += -L/lib/w32api
        DESTDIR = c:/
        SOURCES+=$$BASE_DIR/Support/glew/glew.c
        INCLUDEPATH+=$$BASE_DIR/Support/glew/
        DEFINES+=_WIN32
        CONFIG+=dll
        DEFINES+=BUILDING_DLL

}

# if we are on a mac define DARWIN
macx:DEFINES += DARWIN

# this is where to look for includes
INCLUDEPATH += $$BASE_DIR/include/ngl
INCLUDEPATH += $$BASE_DIR/src/ngl

# do the same for image magick
LIBS += -L/usr/local/lib

# set the SRC_DIR so we can find the project files
SRC_DIR = $$BASE_DIR/src
# the unix flag works for both Mac and Linux if we want linux only
# we need to use the linux-g++ flag
linux-g++:{
          DEFINES += LINUX
          LIBS+=-lGLEW
}

linux-g++-64:{
          DEFINES += LINUX
          LIBS+=-lGLEW
}
# and the include files
INC_DIR = $$BASE_DIR/include/ngl
DEPENDPATH= $$INC_DIR

SOURCES += $$SRC_DIR/Vector.cpp \
    $$SRC_DIR/VBOPrimitives.cpp \
    $$SRC_DIR/Util.cpp \
    $$SRC_DIR/Texture.cpp \
    $$SRC_DIR/SpotLight.cpp \
    $$SRC_DIR/ShaderManager.cpp \
    $$SRC_DIR/Transformation.cpp \
    $$SRC_DIR/RibExport.cpp \
    $$SRC_DIR/Quaternion.cpp \
    $$SRC_DIR/PathCamera.cpp \
    $$SRC_DIR/Obj.cpp \
    $$SRC_DIR/Matrix.cpp \
    $$SRC_DIR/TransformStack.cpp \
    $$SRC_DIR/Material.cpp \
    $$SRC_DIR/Light.cpp \
    $$SRC_DIR/NGLInit.cpp \
    $$SRC_DIR/Colour.cpp \
    $$SRC_DIR/Clip.cpp \
    $$SRC_DIR/Camera.cpp \
    $$SRC_DIR/NCCABinMesh.cpp \
    $$SRC_DIR/BezierCurve.cpp \
    $$SRC_DIR/BBox.cpp \
    $$SRC_DIR/AbstractMesh.cpp \
    $$SRC_DIR/HoudiniGeo.cpp \
    $$SRC_DIR/Random.cpp \
    $$SRC_DIR/NCCAPointBake.cpp \
    $$SRC_DIR/Shader.cpp \
    $$SRC_DIR/ShaderProgram.cpp \
		$$SRC_DIR/Plane.cpp \
		$$SRC_DIR/AABB.cpp \
		$$SRC_DIR/VertexArrayObject.cpp


HEADERS += $$INC_DIR/Vector.h \
    $$INC_DIR/VBOPrimitives.h \
    $$INC_DIR/Singleton.h \
    $$INC_DIR/Util.h \
    $$INC_DIR/Types.h \
    $$INC_DIR/Texture.h \
    $$INC_DIR/SpotLight.h \
    $$INC_DIR/ShaderManager.h \
    $$INC_DIR/RibExport.h \
    $$INC_DIR/Transformation.h \
    $$INC_DIR/Quaternion.h \
    $$INC_DIR/PathCamera.h \
    $$INC_DIR/Obj.h \
    $$INC_DIR/NGLassert.h \
    $$INC_DIR/Matrix.h \
    $$INC_DIR/TransformStack.h \
    $$INC_DIR/Material.h \
    $$INC_DIR/Light.h \
    $$INC_DIR/NGLInit.h \
    $$INC_DIR/Colour.h \
    $$INC_DIR/Clip.h \
    $$INC_DIR/Camera.h \
    $$INC_DIR/BezierCurve.h \
    $$INC_DIR/NCCABinMesh.h \
    $$INC_DIR/BBox.h \
    $$INC_DIR/AbstractMesh.h \
    $$INC_DIR/HoudiniGeo.h \
    $$INC_DIR/Random.h \
    $$INC_DIR/NCCAPointBake.h \
    $$INC_DIR/Shader.h \
    $$INC_DIR/ShaderProgram.h \
		$$INC_DIR/Plane.h \
		$$INC_DIR/AABB.h \
		$$INC_DIR/VertexArrayObject.h


PYTHON_DIR=$$BASE_DIR/python
OTHER_FILES+= Doxyfile \
