#ifndef __CLIP_INC_H__
#define __CLIP_INC_H__

// import the namespace for convenience
using namespace boost::python;
// now we define a python class for the code
// above

class_<Clip, boost::noncopyable>("Clip")
    /// we have to define an init method for
    /// each possible version available in the header
    .def(init<const std::string &>())
    .def(init<const std::string  &,const std::string &>())
    .def(init<const std::string&,const std::string &,const std::string &>())
    .def(init<>())
    // prototype the methods
    .def("setObj", &Clip::setObj)
    .def("draw",drawC)
    .def("draw",drawI)
    .def("setFrame", &Clip::setFrame)
    .def("loadClip", &Clip::loadClip)
    .def("updateVerts", &Clip::updateVerts)
    .def("getCurrentFrame", &Clip::getCurrentFrame)
    .def("getNumFrames", &Clip::getNumFrames)
;

#endif

