#ifndef __LIGHT_INC_H__
#define __LIGHT_INC_H__

// import the namespace for convenience
using namespace boost::python;



enum_<LIGHTMODES>("LIGHTMODES")
    .value("LIGHTREMOTE", LIGHTREMOTE)
    .value("LIGHTLOCAL", LIGHTLOCAL)
    ;

// now we define a python class for the code
// above
class_<Light>("Light")
    /// we have to define an init method for
    /// each possible version available in the header

    .def(init<ngl::Vector, ngl::Colour,LIGHTMODES>())
    .def(init<ngl::Vector,ngl::Colour,ngl::Colour,LIGHTMODES>())
    .def(init<>())
    // prototype the methods
    .def("setPosition", &Light::setPosition)
    .def("setColour", &Light::setColour)
    .def("setSpecColour", &Light::setSpecColour)
    .def("setPosition", &Light::setPosition)
    .def("disable", &Light::disable)
    .def("enable", &Light::enable)
    .def("setAttenuation", &Light::setAttenuation)
    .def("getNumEnabledLights", &Light::getNumEnabledLights)
    .def("show", &Light::show)
    .def("getLightNum", &Light::getLightNum)
    .def("getPos", &Light::getPos,return_value_policy<reference_existing_object>())
    .def("getColour", &Light::getColour,return_value_policy<reference_existing_object>())

;

#endif

