#ifndef __PATHCAMERA_INC_H__
#define __PATHCAMERA_INC_H__

// import the namespace for convenience
using namespace boost::python;

class_<PathCamera, bases<Camera> >("PathCamera")
    /// we have to define an init method for
    /// each possible version available above
    .def(init<const Vector &,const BezierCurve &,const BezierCurve &,const Real,const CAMERAPROJECTION >())
    .def(init<const Vector &,Vector const *,int ,Vector const  *,int ,Real ,CAMERAPROJECTION >())
    .def(init<const Vector &,const std::string &,Real,CAMERAPROJECTION >())
    .def("update",&PathCamera::update)
    .def("updateLooped",&PathCamera::updateLooped)
    .def("drawPaths",&PathCamera::drawPaths)
    .def("loadPath",&PathCamera::loadPath)
    .def("createCurvesForDrawing",&PathCamera::setOrthoParams)

    ;



#endif

