#ifndef __SHADERMANAGER_INC_H__
#define __SHADERMANAGER_INC_H__
// import the namespace for convenience
using namespace boost::python;

/// notice no_init and nocopyable as singleton,

class_<ShaderManager, boost::noncopyable>("ShaderManager",no_init)
    /// we have to define an init method for
    /// each possible version available above

    .def("instance", &ShaderManager::instance,
      return_value_policy<reference_existing_object>()).staticmethod("instance")

    .def("loadShader",&ShaderManager::loadShader)
    .def("debugOn",&ShaderManager::debugOn)
    .def("debugOff",&ShaderManager::debugOff)
    .def("getNumShaders",&ShaderManager::getNumShaders)
    .def("setShaderParamFromMatrix",&ShaderManager::setShaderParamFromMatrix)
    .def("setShaderParamFromVector",&ShaderManager::setShaderParamFromVector)
    .def("setShaderParam1i",&ShaderManager::setShaderParam1i)
    .def("setShaderParam1f",&ShaderManager::setShaderParam1f)
    .def("setShaderParam2f",&ShaderManager::setShaderParam2f)
    .def("setShaderParam3f",&ShaderManager::setShaderParam3f)
    .def("setShaderParam4f",&ShaderManager::setShaderParam4f)
    .def("useShader",&ShaderManager::useShader)
		.def("createShaderProgram",&ShaderManager::createShaderProgram)

.def("attachShader",&ShaderManager::attachShader)
.def("attachShaderToProgram",&ShaderManager::attachShaderToProgram)
.def("getProgramID",&ShaderManager::getProgramID)
.def("compileShader",&ShaderManager::compileShader)
.def("linkProgramObject",&ShaderManager::linkProgramObject)
.def("use",&ShaderManager::use)
.def("bindAttribute",&ShaderManager::bindAttribute)
.def("createShaderProgram",&ShaderManager::createShaderProgram)
.def("loadShaderSource",&ShaderManager::loadShaderSource)
.def("reset",&ShaderManager::reset)
.def("getAttribLocation",&ShaderManager::getAttribLocation)
.def("getShaderProgram",&ShaderManager::getShaderProgram,return_value_policy<manage_new_object>());
 ;

/*




  ShaderProgram * operator[](const std::string &_programName);
  ShaderProgram * operator[](const char *_programName);



  GLhandleARB operator[](
                         const ShaderManager&
                        );



 */

#endif


